/*
 * Copyright (c) IntellectualCrafters - 2014. You are not allowed to distribute
 * and/or monetize any of our intellectual property. IntellectualCrafters is not
 * affiliated with Mojang AB. Minecraft is a trademark of Mojang AB.
 * 
 * >> File = SetOwner.java >> Generated by: Citymonstret at 2014-08-09 01:42
 */

package com.intellectualcrafters.plot.commands;

import java.util.UUID;

import org.bukkit.entity.Player;

import com.intellectualcrafters.plot.C;
import com.intellectualcrafters.plot.PlayerFunctions;
import com.intellectualcrafters.plot.Plot;
import com.intellectualcrafters.plot.PlotMain;
import com.intellectualcrafters.plot.UUIDHandler;
import com.intellectualcrafters.plot.database.DBFunc;

@SuppressWarnings("deprecation")
public class SetOwner extends SubCommand {

	public SetOwner() {
		super("setowner", "plots.admin", "Set the plot owner", "setowner {player}", "so", CommandCategory.ACTIONS, true);
	}

	/*
	 * private UUID getUUID(String string) { OfflinePlayer player =
	 * Bukkit.getOfflinePlayer(string); return ((player != null) &&
	 * player.hasPlayedBefore()) ? player.getUniqueId() : null; }
	 */

	private UUID getUUID(String string) {
		return UUIDHandler.getUUID(string);
	}

	@Override
	public boolean execute(Player plr, String... args) {
		if (!PlayerFunctions.isInPlot(plr)) {
			PlayerFunctions.sendMessage(plr, C.NOT_IN_PLOT);
			return true;
		}
		Plot plot = PlayerFunctions.getCurrentPlot(plr);
		if (args.length < 1) {
			PlayerFunctions.sendMessage(plr, C.NEED_USER);
			return true;
		}
		plot.owner = getUUID(args[0]);
		PlotMain.updatePlot(plot);
		DBFunc.setOwner(plot, plot.owner);
		PlayerFunctions.sendMessage(plr, C.SET_OWNER);
		
		if (PlotMain.worldGuardListener!=null) {
		    PlotMain.worldGuardListener.changeOwner(plr, plot.owner, plr.getWorld(), plot);
		}
		
		return true;
	}
}
